Interface HttpEndpointBuilderFactory.HttpEndpointBuilder
- All Superinterfaces:
org.apache.camel.builder.EndpointProducerBuilder,org.apache.camel.EndpointProducerResolver
- Enclosing interface:
HttpEndpointBuilderFactory
public static interface HttpEndpointBuilderFactory.HttpEndpointBuilder
extends org.apache.camel.builder.EndpointProducerBuilder
Builder for endpoint for the HTTP component.
-
Method Summary
Modifier and TypeMethodDescriptionadvanced()authDomain(String authDomain) Authentication domain to use with NTML.authenticationPreemptive(boolean authenticationPreemptive) If this option is true, camel-http sends preemptive basic authentication to the server.authenticationPreemptive(String authenticationPreemptive) If this option is true, camel-http sends preemptive basic authentication to the server.Authentication host to use with NTML.authMethod(String authMethod) Authentication methods allowed to use as a comma separated list of values Basic, Digest or NTLM.authMethodPriority(String authMethodPriority) Which authentication method to prioritize to use, either as Basic, Digest or NTLM.authPassword(String authPassword) Authentication password.authUsername(String authUsername) Authentication username.bridgeEndpoint(boolean bridgeEndpoint) If the option is true, HttpProducer will ignore the Exchange.HTTP_URI header, and use the endpoint's URI for request.bridgeEndpoint(String bridgeEndpoint) If the option is true, HttpProducer will ignore the Exchange.HTTP_URI header, and use the endpoint's URI for request.connectionClose(boolean connectionClose) Specifies whether a Connection Close header must be added to HTTP Request.connectionClose(String connectionClose) Specifies whether a Connection Close header must be added to HTTP Request.disableStreamCache(boolean disableStreamCache) Determines whether or not the raw input stream is cached or not.disableStreamCache(String disableStreamCache) Determines whether or not the raw input stream is cached or not.httpMethod(String httpMethod) Configure the HTTP method to use.httpMethod(org.apache.camel.http.common.HttpMethods httpMethod) Configure the HTTP method to use.logHttpActivity(boolean logHttpActivity) To enable logging HTTP request and response.logHttpActivity(String logHttpActivity) To enable logging HTTP request and response.oauth2CachedTokensDefaultExpirySeconds(long oauth2CachedTokensDefaultExpirySeconds) Default expiration time for cached OAuth2 tokens, in seconds.oauth2CachedTokensDefaultExpirySeconds(String oauth2CachedTokensDefaultExpirySeconds) Default expiration time for cached OAuth2 tokens, in seconds.oauth2CachedTokensExpirationMarginSeconds(long oauth2CachedTokensExpirationMarginSeconds) Amount of time which is deducted from OAuth2 tokens expiry time to compensate for the time it takes OAuth2 Token Endpoint to send the token over http, in seconds.oauth2CachedTokensExpirationMarginSeconds(String oauth2CachedTokensExpirationMarginSeconds) Amount of time which is deducted from OAuth2 tokens expiry time to compensate for the time it takes OAuth2 Token Endpoint to send the token over http, in seconds.oauth2CacheTokens(boolean oauth2CacheTokens) Whether to cache OAuth2 client tokens.oauth2CacheTokens(String oauth2CacheTokens) Whether to cache OAuth2 client tokens.oauth2ClientId(String oauth2ClientId) OAuth2 client id.oauth2ClientSecret(String oauth2ClientSecret) OAuth2 client secret.oauth2Scope(String oauth2Scope) OAuth2 scope.oauth2TokenEndpoint(String oauth2TokenEndpoint) OAuth2 Token endpoint.proxyAuthDomain(String proxyAuthDomain) Proxy authentication domain to use with NTML.proxyAuthHost(String proxyAuthHost) Proxy authentication host.proxyAuthMethod(String proxyAuthMethod) Proxy authentication method to use.proxyAuthNtHost(String proxyAuthNtHost) Proxy authentication domain (workstation name) to use with NTML.proxyAuthPassword(String proxyAuthPassword) Proxy authentication password.proxyAuthPort(int proxyAuthPort) Proxy authentication port.proxyAuthPort(String proxyAuthPort) Proxy authentication port.proxyAuthScheme(String proxyAuthScheme) Proxy authentication scheme to use.proxyAuthUsername(String proxyAuthUsername) Proxy authentication username.Proxy hostname to use.proxyPort(int proxyPort) Proxy port to use.Proxy port to use.skipRequestHeaders(boolean skipRequestHeaders) Whether to skip mapping all the Camel headers as HTTP request headers.skipRequestHeaders(String skipRequestHeaders) Whether to skip mapping all the Camel headers as HTTP request headers.skipResponseHeaders(boolean skipResponseHeaders) Whether to skip mapping all the HTTP response headers to Camel headers.skipResponseHeaders(String skipResponseHeaders) Whether to skip mapping all the HTTP response headers to Camel headers.sslContextParameters(String sslContextParameters) To configure security using SSLContextParameters.sslContextParameters(org.apache.camel.support.jsse.SSLContextParameters sslContextParameters) To configure security using SSLContextParameters.throwExceptionOnFailure(boolean throwExceptionOnFailure) Option to disable throwing the HttpOperationFailedException in case of failed responses from the remote server.throwExceptionOnFailure(String throwExceptionOnFailure) Option to disable throwing the HttpOperationFailedException in case of failed responses from the remote server.x509HostnameVerifier(String x509HostnameVerifier) To use a custom X509HostnameVerifier such as DefaultHostnameVerifier or NoopHostnameVerifier.x509HostnameVerifier(HostnameVerifier x509HostnameVerifier) To use a custom X509HostnameVerifier such as DefaultHostnameVerifier or NoopHostnameVerifier.Methods inherited from interface org.apache.camel.builder.EndpointProducerBuilder
doSetMultiValueProperties, doSetMultiValueProperty, doSetProperty, expr, getRawUri, getUriMethods inherited from interface org.apache.camel.EndpointProducerResolver
resolve, resolve
-
Method Details
-
advanced
-
disableStreamCache
default HttpEndpointBuilderFactory.HttpEndpointBuilder disableStreamCache(boolean disableStreamCache) Determines whether or not the raw input stream is cached or not. The Camel consumer (camel-servlet, camel-jetty etc.) will by default cache the input stream to support reading it multiple times to ensure it Camel can retrieve all data from the stream. However you can set this option to true when you for example need to access the raw stream, such as streaming it directly to a file or other persistent store. DefaultHttpBinding will copy the request input stream into a stream cache and put it into message body if this option is false to support reading the stream multiple times. If you use Servlet to bridge/proxy an endpoint then consider enabling this option to improve performance, in case you do not need to read the message payload multiple times. The producer (camel-http) will by default cache the response body stream. If setting this option to true, then the producers will not cache the response body stream but use the response stream as-is (the stream can only be read once) as the message body. The option is a:booleantype. Default: false Group: common- Parameters:
disableStreamCache- the value to set- Returns:
- the dsl builder
-
disableStreamCache
default HttpEndpointBuilderFactory.HttpEndpointBuilder disableStreamCache(String disableStreamCache) Determines whether or not the raw input stream is cached or not. The Camel consumer (camel-servlet, camel-jetty etc.) will by default cache the input stream to support reading it multiple times to ensure it Camel can retrieve all data from the stream. However you can set this option to true when you for example need to access the raw stream, such as streaming it directly to a file or other persistent store. DefaultHttpBinding will copy the request input stream into a stream cache and put it into message body if this option is false to support reading the stream multiple times. If you use Servlet to bridge/proxy an endpoint then consider enabling this option to improve performance, in case you do not need to read the message payload multiple times. The producer (camel-http) will by default cache the response body stream. If setting this option to true, then the producers will not cache the response body stream but use the response stream as-is (the stream can only be read once) as the message body. The option will be converted to abooleantype. Default: false Group: common- Parameters:
disableStreamCache- the value to set- Returns:
- the dsl builder
-
bridgeEndpoint
If the option is true, HttpProducer will ignore the Exchange.HTTP_URI header, and use the endpoint's URI for request. You may also set the option throwExceptionOnFailure to be false to let the HttpProducer send all the fault response back. The option is a:booleantype. Default: false Group: producer- Parameters:
bridgeEndpoint- the value to set- Returns:
- the dsl builder
-
bridgeEndpoint
If the option is true, HttpProducer will ignore the Exchange.HTTP_URI header, and use the endpoint's URI for request. You may also set the option throwExceptionOnFailure to be false to let the HttpProducer send all the fault response back. The option will be converted to abooleantype. Default: false Group: producer- Parameters:
bridgeEndpoint- the value to set- Returns:
- the dsl builder
-
connectionClose
Specifies whether a Connection Close header must be added to HTTP Request. By default connectionClose is false. The option is a:booleantype. Default: false Group: producer- Parameters:
connectionClose- the value to set- Returns:
- the dsl builder
-
connectionClose
Specifies whether a Connection Close header must be added to HTTP Request. By default connectionClose is false. The option will be converted to abooleantype. Default: false Group: producer- Parameters:
connectionClose- the value to set- Returns:
- the dsl builder
-
httpMethod
default HttpEndpointBuilderFactory.HttpEndpointBuilder httpMethod(org.apache.camel.http.common.HttpMethods httpMethod) Configure the HTTP method to use. The HttpMethod header cannot override this option if set. The option is a:org.apache.camel.http.common.HttpMethodstype. Group: producer- Parameters:
httpMethod- the value to set- Returns:
- the dsl builder
-
httpMethod
Configure the HTTP method to use. The HttpMethod header cannot override this option if set. The option will be converted to aorg.apache.camel.http.common.HttpMethodstype. Group: producer- Parameters:
httpMethod- the value to set- Returns:
- the dsl builder
-
logHttpActivity
To enable logging HTTP request and response. You can use a custom LoggingHttpActivityListener as httpActivityListener to control logging options. The option is a:booleantype. Default: false Group: producer- Parameters:
logHttpActivity- the value to set- Returns:
- the dsl builder
-
logHttpActivity
To enable logging HTTP request and response. You can use a custom LoggingHttpActivityListener as httpActivityListener to control logging options. The option will be converted to abooleantype. Default: false Group: producer- Parameters:
logHttpActivity- the value to set- Returns:
- the dsl builder
-
skipRequestHeaders
default HttpEndpointBuilderFactory.HttpEndpointBuilder skipRequestHeaders(boolean skipRequestHeaders) Whether to skip mapping all the Camel headers as HTTP request headers. If there are no data from Camel headers needed to be included in the HTTP request then this can avoid parsing overhead with many object allocations for the JVM garbage collector. The option is a:booleantype. Default: false Group: producer- Parameters:
skipRequestHeaders- the value to set- Returns:
- the dsl builder
-
skipRequestHeaders
default HttpEndpointBuilderFactory.HttpEndpointBuilder skipRequestHeaders(String skipRequestHeaders) Whether to skip mapping all the Camel headers as HTTP request headers. If there are no data from Camel headers needed to be included in the HTTP request then this can avoid parsing overhead with many object allocations for the JVM garbage collector. The option will be converted to abooleantype. Default: false Group: producer- Parameters:
skipRequestHeaders- the value to set- Returns:
- the dsl builder
-
skipResponseHeaders
default HttpEndpointBuilderFactory.HttpEndpointBuilder skipResponseHeaders(boolean skipResponseHeaders) Whether to skip mapping all the HTTP response headers to Camel headers. If there are no data needed from HTTP headers then this can avoid parsing overhead with many object allocations for the JVM garbage collector. The option is a:booleantype. Default: false Group: producer- Parameters:
skipResponseHeaders- the value to set- Returns:
- the dsl builder
-
skipResponseHeaders
default HttpEndpointBuilderFactory.HttpEndpointBuilder skipResponseHeaders(String skipResponseHeaders) Whether to skip mapping all the HTTP response headers to Camel headers. If there are no data needed from HTTP headers then this can avoid parsing overhead with many object allocations for the JVM garbage collector. The option will be converted to abooleantype. Default: false Group: producer- Parameters:
skipResponseHeaders- the value to set- Returns:
- the dsl builder
-
throwExceptionOnFailure
default HttpEndpointBuilderFactory.HttpEndpointBuilder throwExceptionOnFailure(boolean throwExceptionOnFailure) Option to disable throwing the HttpOperationFailedException in case of failed responses from the remote server. This allows you to get all responses regardless of the HTTP status code. The option is a:booleantype. Default: true Group: producer- Parameters:
throwExceptionOnFailure- the value to set- Returns:
- the dsl builder
-
throwExceptionOnFailure
default HttpEndpointBuilderFactory.HttpEndpointBuilder throwExceptionOnFailure(String throwExceptionOnFailure) Option to disable throwing the HttpOperationFailedException in case of failed responses from the remote server. This allows you to get all responses regardless of the HTTP status code. The option will be converted to abooleantype. Default: true Group: producer- Parameters:
throwExceptionOnFailure- the value to set- Returns:
- the dsl builder
-
proxyAuthDomain
Proxy authentication domain to use with NTML. The option is a:java.lang.Stringtype. Group: proxy- Parameters:
proxyAuthDomain- the value to set- Returns:
- the dsl builder
-
proxyAuthHost
Proxy authentication host. The option is a:java.lang.Stringtype. Group: proxy- Parameters:
proxyAuthHost- the value to set- Returns:
- the dsl builder
-
proxyAuthMethod
Proxy authentication method to use. The option is a:java.lang.Stringtype. Group: proxy- Parameters:
proxyAuthMethod- the value to set- Returns:
- the dsl builder
-
proxyAuthNtHost
Proxy authentication domain (workstation name) to use with NTML. The option is a:java.lang.Stringtype. Group: proxy- Parameters:
proxyAuthNtHost- the value to set- Returns:
- the dsl builder
-
proxyAuthPassword
Proxy authentication password. The option is a:java.lang.Stringtype. Group: proxy- Parameters:
proxyAuthPassword- the value to set- Returns:
- the dsl builder
-
proxyAuthPort
Proxy authentication port. The option is a:inttype. Group: proxy- Parameters:
proxyAuthPort- the value to set- Returns:
- the dsl builder
-
proxyAuthPort
Proxy authentication port. The option will be converted to ainttype. Group: proxy- Parameters:
proxyAuthPort- the value to set- Returns:
- the dsl builder
-
proxyAuthScheme
Proxy authentication scheme to use. The option is a:java.lang.Stringtype. Group: proxy- Parameters:
proxyAuthScheme- the value to set- Returns:
- the dsl builder
-
proxyAuthUsername
Proxy authentication username. The option is a:java.lang.Stringtype. Group: proxy- Parameters:
proxyAuthUsername- the value to set- Returns:
- the dsl builder
-
proxyHost
Proxy hostname to use. The option is a:java.lang.Stringtype. Group: proxy- Parameters:
proxyHost- the value to set- Returns:
- the dsl builder
-
proxyPort
Proxy port to use. The option is a:inttype. Group: proxy- Parameters:
proxyPort- the value to set- Returns:
- the dsl builder
-
proxyPort
Proxy port to use. The option will be converted to ainttype. Group: proxy- Parameters:
proxyPort- the value to set- Returns:
- the dsl builder
-
authDomain
Authentication domain to use with NTML. The option is a:java.lang.Stringtype. Group: security- Parameters:
authDomain- the value to set- Returns:
- the dsl builder
-
authenticationPreemptive
default HttpEndpointBuilderFactory.HttpEndpointBuilder authenticationPreemptive(boolean authenticationPreemptive) If this option is true, camel-http sends preemptive basic authentication to the server. The option is a:booleantype. Default: false Group: security- Parameters:
authenticationPreemptive- the value to set- Returns:
- the dsl builder
-
authenticationPreemptive
default HttpEndpointBuilderFactory.HttpEndpointBuilder authenticationPreemptive(String authenticationPreemptive) If this option is true, camel-http sends preemptive basic authentication to the server. The option will be converted to abooleantype. Default: false Group: security- Parameters:
authenticationPreemptive- the value to set- Returns:
- the dsl builder
-
authHost
Authentication host to use with NTML. The option is a:java.lang.Stringtype. Group: security- Parameters:
authHost- the value to set- Returns:
- the dsl builder
-
authMethod
Authentication methods allowed to use as a comma separated list of values Basic, Digest or NTLM. The option is a:java.lang.Stringtype. Group: security- Parameters:
authMethod- the value to set- Returns:
- the dsl builder
-
authMethodPriority
default HttpEndpointBuilderFactory.HttpEndpointBuilder authMethodPriority(String authMethodPriority) Which authentication method to prioritize to use, either as Basic, Digest or NTLM. The option is a:java.lang.Stringtype. Group: security- Parameters:
authMethodPriority- the value to set- Returns:
- the dsl builder
-
authPassword
Authentication password. The option is a:java.lang.Stringtype. Group: security- Parameters:
authPassword- the value to set- Returns:
- the dsl builder
-
authUsername
Authentication username. The option is a:java.lang.Stringtype. Group: security- Parameters:
authUsername- the value to set- Returns:
- the dsl builder
-
oauth2CachedTokensDefaultExpirySeconds
default HttpEndpointBuilderFactory.HttpEndpointBuilder oauth2CachedTokensDefaultExpirySeconds(long oauth2CachedTokensDefaultExpirySeconds) Default expiration time for cached OAuth2 tokens, in seconds. Used if token response does not contain 'expires_in' field. The option is a:longtype. Default: 3600 Group: security- Parameters:
oauth2CachedTokensDefaultExpirySeconds- the value to set- Returns:
- the dsl builder
-
oauth2CachedTokensDefaultExpirySeconds
default HttpEndpointBuilderFactory.HttpEndpointBuilder oauth2CachedTokensDefaultExpirySeconds(String oauth2CachedTokensDefaultExpirySeconds) Default expiration time for cached OAuth2 tokens, in seconds. Used if token response does not contain 'expires_in' field. The option will be converted to alongtype. Default: 3600 Group: security- Parameters:
oauth2CachedTokensDefaultExpirySeconds- the value to set- Returns:
- the dsl builder
-
oauth2CachedTokensExpirationMarginSeconds
default HttpEndpointBuilderFactory.HttpEndpointBuilder oauth2CachedTokensExpirationMarginSeconds(long oauth2CachedTokensExpirationMarginSeconds) Amount of time which is deducted from OAuth2 tokens expiry time to compensate for the time it takes OAuth2 Token Endpoint to send the token over http, in seconds. Set this parameter to high value if you OAuth2 Token Endpoint answers slowly or you tokens expire quickly. If you set this parameter to too small value, you can get 4xx http errors because camel will think that the received token is still valid, while in reality the token is expired for the Authentication server. The option is a:longtype. Default: 5 Group: security- Parameters:
oauth2CachedTokensExpirationMarginSeconds- the value to set- Returns:
- the dsl builder
-
oauth2CachedTokensExpirationMarginSeconds
default HttpEndpointBuilderFactory.HttpEndpointBuilder oauth2CachedTokensExpirationMarginSeconds(String oauth2CachedTokensExpirationMarginSeconds) Amount of time which is deducted from OAuth2 tokens expiry time to compensate for the time it takes OAuth2 Token Endpoint to send the token over http, in seconds. Set this parameter to high value if you OAuth2 Token Endpoint answers slowly or you tokens expire quickly. If you set this parameter to too small value, you can get 4xx http errors because camel will think that the received token is still valid, while in reality the token is expired for the Authentication server. The option will be converted to alongtype. Default: 5 Group: security- Parameters:
oauth2CachedTokensExpirationMarginSeconds- the value to set- Returns:
- the dsl builder
-
oauth2CacheTokens
Whether to cache OAuth2 client tokens. The option is a:booleantype. Default: false Group: security- Parameters:
oauth2CacheTokens- the value to set- Returns:
- the dsl builder
-
oauth2CacheTokens
Whether to cache OAuth2 client tokens. The option will be converted to abooleantype. Default: false Group: security- Parameters:
oauth2CacheTokens- the value to set- Returns:
- the dsl builder
-
oauth2ClientId
OAuth2 client id. The option is a:java.lang.Stringtype. Group: security- Parameters:
oauth2ClientId- the value to set- Returns:
- the dsl builder
-
oauth2ClientSecret
default HttpEndpointBuilderFactory.HttpEndpointBuilder oauth2ClientSecret(String oauth2ClientSecret) OAuth2 client secret. The option is a:java.lang.Stringtype. Group: security- Parameters:
oauth2ClientSecret- the value to set- Returns:
- the dsl builder
-
oauth2Scope
OAuth2 scope. The option is a:java.lang.Stringtype. Group: security- Parameters:
oauth2Scope- the value to set- Returns:
- the dsl builder
-
oauth2TokenEndpoint
default HttpEndpointBuilderFactory.HttpEndpointBuilder oauth2TokenEndpoint(String oauth2TokenEndpoint) OAuth2 Token endpoint. The option is a:java.lang.Stringtype. Group: security- Parameters:
oauth2TokenEndpoint- the value to set- Returns:
- the dsl builder
-
sslContextParameters
default HttpEndpointBuilderFactory.HttpEndpointBuilder sslContextParameters(org.apache.camel.support.jsse.SSLContextParameters sslContextParameters) To configure security using SSLContextParameters. Important: Only one instance of org.apache.camel.util.jsse.SSLContextParameters is supported per HttpComponent. If you need to use 2 or more different instances, you need to define a new HttpComponent per instance you need. The option is a:org.apache.camel.support.jsse.SSLContextParameterstype. Group: security- Parameters:
sslContextParameters- the value to set- Returns:
- the dsl builder
-
sslContextParameters
default HttpEndpointBuilderFactory.HttpEndpointBuilder sslContextParameters(String sslContextParameters) To configure security using SSLContextParameters. Important: Only one instance of org.apache.camel.util.jsse.SSLContextParameters is supported per HttpComponent. If you need to use 2 or more different instances, you need to define a new HttpComponent per instance you need. The option will be converted to aorg.apache.camel.support.jsse.SSLContextParameterstype. Group: security- Parameters:
sslContextParameters- the value to set- Returns:
- the dsl builder
-
x509HostnameVerifier
default HttpEndpointBuilderFactory.HttpEndpointBuilder x509HostnameVerifier(HostnameVerifier x509HostnameVerifier) To use a custom X509HostnameVerifier such as DefaultHostnameVerifier or NoopHostnameVerifier. The option is a:javax.net.ssl.HostnameVerifiertype. Group: security- Parameters:
x509HostnameVerifier- the value to set- Returns:
- the dsl builder
-
x509HostnameVerifier
default HttpEndpointBuilderFactory.HttpEndpointBuilder x509HostnameVerifier(String x509HostnameVerifier) To use a custom X509HostnameVerifier such as DefaultHostnameVerifier or NoopHostnameVerifier. The option will be converted to ajavax.net.ssl.HostnameVerifiertype. Group: security- Parameters:
x509HostnameVerifier- the value to set- Returns:
- the dsl builder
-